/*
 * Copyright (C) 2007 INdT - Instituto Nokia de Tecnologia . All rights reserved.
 *
 * This file is part of Download Manager
 *
 * Contact: Leonardo Sobral Cunha <leonardo.cunha@openbossa.org>
 *
 * This software, including documentation, is protected by copyright
 * controlled by Instituto Nokia de Tecnologia. All rights are reserved.
 * Copying, including reproducing, storing, adapting or translating, any
 * or all of this material requires the prior written consent of
 * Instituto Nokia de Tecnologia. This material also contains
 * confidential information which may not be disclosed to others without
 * the prior written consent of Instituto Nokia de Tecnologia.
 */

#ifndef __CNL_DOWNLOAD_MANAGER_H__
#define __CNL_DOWNLOAD_MANAGER_H__

#include <glib.h>
#include <glib-object.h>
#include <dbus/dbus-glib.h>

#include "cnl-download-item.h"

G_BEGIN_DECLS

#define CNL_DOWNLOAD_MANAGER_TYPE \
    (cnl_download_manager_get_type ())
#define CNL_DOWNLOAD_MANAGER(o) \
    (G_TYPE_CHECK_INSTANCE_CAST ((o), CNL_DOWNLOAD_MANAGER_TYPE, CnlDownloadManager))
#define CNL_DOWNLOAD_MANAGER_CLASS(k) \
    (G_TYPE_CHECK_CLASS_CAST((k), CNL_DOWNLOAD_MANAGER_TYPE, CnlDownloadManagerClass))
#define IS_CNL_DOWNLOAD_MANAGER(o) \
    (G_TYPE_CHECK_INSTANCE_TYPE ((o), CNL_DOWNLOAD_MANAGER_TYPE))
#define IS_CNL_DOWNLOAD_MANAGER_CLASS(k) \
    (G_TYPE_CHECK_CLASS_TYPE ((k), CNL_DOWNLOAD_MANAGER_TYPE))
#define CNL_DOWNLOAD_MANAGER_GET_CLASS(o) \
    (G_TYPE_INSTANCE_GET_CLASS ((o), CNL_DOWNLOAD_MANAGER_TYPE, CnlDownloadManagerClass))

typedef struct _CnlDownloadManager        CnlDownloadManager;
typedef struct _CnlDownloadManagerClass   CnlDownloadManagerClass;
typedef struct _CnlDownloadManagerPrivate CnlDownloadManagerPrivate;

struct _CnlDownloadManagerClass {
    GObjectClass parent;
};

struct _CnlDownloadManager {
    GObject parent;
};

void                (*InactivityFunc) (gpointer data);

GType               cnl_download_manager_get_type (void);

guint64             cnl_download_manager_get_size (const gchar* url);

CnlDownloadItem*    cnl_download_manager_add (CnlDownloadManager *self,
                                              const gchar *url,
                                              const gchar *dest_filename);

gboolean            cnl_download_manager_start_dbus_service (CnlDownloadManager *self);

void                cnl_download_manager_inactivity_cb_add (CnlDownloadManager *self,
                                                            guint timeout,
                                                            GSourceFunc inactivity_cb,
                                                            gpointer user_data);
G_END_DECLS

#endif
